#!/usr/bin/env python3                                                                                                                         
# exec(open('/esarchive/scratch/hpetetin/script/bigdata_tutorial/test.py').read())                             
           
import xarray as xr
import numpy as np
import matplotlib.pyplot as plt
import multiprocessing
import os
import psutil
import glob
import time
import datetime




# Method 1/parallel (FAST)
time0 = time.time()
ds = xr.open_mfdataset('/esarchive/recon/ecmwf/era5/1hourly/tas/tas_2019*.nc', combine='by_coords', coords=['time'], parallel=True)
time1 = time.time()
print('  (duration={}) xr.open_mfdataset / parallel'.format(str(datetime.timedelta(seconds=time1-time0))))
print('size(ds) = {:0.3}GB'.format(ds.nbytes/1e9))



time0 = time.time()  
dsp = ds.persist()
time1 = time.time()
print('  (duration={}) persist() '.format(str(datetime.timedelta(seconds=time1-time0))))

zz
# Method 1 (FAST)
time0 = time.time()
ds = xr.open_mfdataset('/esarchive/recon/ecmwf/era5/1hourly/tas/tas_2019*.nc', combine='by_coords', coords=['time'])
time1 = time.time()
przint('  (duration={}) xr.open_mfdataset '.format(str(datetime.timedelta(seconds=time1-time0))))
print('size(ds) = {:0.3}GB'.format(ds.nbytes/1e9))

zzz
# Method 2 (6:19 SLOW!)
time0 = time.time()
ds = xr.concat([xr.open_dataset(f) for f in glob.glob('/esarchive/recon/ecmwf/era5/1hourly/tas/tas_2019*.nc')],'time')
time1 = time.time()
print('  (duration={}) xr.open_dataset / concat'.format(str(datetime.timedelta(seconds=time1-time0))))   



'''
files = glob.glob('/esarchive/recon/ecmwf/era5/1hourly/tas/tas_20191*.nc')
ds0 = xr.open_dataset(files[0])
ds1 = xr.open_dataset(files[1])
ds2 = xr.open_dataset(files[2])
ds01 = xr.concat([ds0,ds1],'time')
ds012 = xr.concat([ds0,ds1,ds2],'time')
zz
'''


